require_relative 'diagnoser'
require_relative 'generator'
require_relative 'options'
require_relative 'runner'
require_relative 'previewer'

module Contraption
  class CommandSelector
    class << self
      def go args
        case args.first
        when 'diagnose'
          args.shift
          Diagnoser
        when 'generate'
          args.shift
          Generator
        when 'preview'
          args.shift
          Previewer
        else
          Runner
        end.send("new", Options.new(args)).run!
      end
    end
  end
end
